/******************************************************************************/
/*                                                                            */
/*                  Wii AES Encrypt/Decrypt Test Ver.0.01a                    */
/*                                                                            */
/*                                            Nekokabu                        */
/*                                                                            */
/*                                       HP:    http://nekokabu.s7.xrea.com/  */
/*                                       Mail:  nekokabu@gmail.com            */
/******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "aes.h"

/*===================================*/
/*  main entry                       */
/*===================================*/
int main(int argc, char* argv[]){


	unsigned char sdkey[16], sdiv[16];
	unsigned int size = 0;
	unsigned char *rBuffer;
	unsigned char *rBuffer2;
	int mode = 0, num = 2;
	char name[2048], c;
	FILE	*fp;

	char szDrive[_MAX_DRIVE];
	char szDir[_MAX_DIR];
	char szFileName[_MAX_FNAME];
	char szExt[_MAX_EXT ];

	////////////////////////////////////
	// print banner
	printf("========================================\n");
	printf(" Wii AES Encrypt/Decrypt Test Ver.0.01a \n");
	printf("                         by Nekokabu    \n");
	printf("========================================\n");
	if( argc < 2 ){
		printf(" usage: wiiaes (-e/d) input\n");
		getchar();
		return 0;
	}

	if(strcmp("-e", argv[1]) == 0){
		mode = 1;
	}
	else if(strcmp("-d", argv[1]) == 0){
		mode = 2;
	}
	else num = 1;



	////////////////////////////////////
	// get path
	_splitpath(argv[0], szDrive, szDir, szFileName, szExt); 
 
	//////////////////////////////////////
	// Load "SD key"
	sprintf(name, "%s%s\\sdkey.bin", szDrive, szDir);

	if((fp = fopen(name, "rb")) == NULL){
		printf("Cannot Open %s\n", name);
		getchar();
		return 0;
	}
	fseek(fp, 0x0L, SEEK_SET);
	fread(sdkey, 16, 1, fp);
	fclose(fp);
	printf("sdkey loaded.\n");

	//////////////////////////////////////
	// Load "SD iv"
	sprintf(name, "%s%s\\sdiv.bin", szDrive, szDir);
	if((fp = fopen(name, "rb")) == NULL){
		printf("Cannot Open %s\n", name);
		getchar();
		return 0;
	}
	fseek(fp, 0x0L, SEEK_SET);
	fread(sdiv, 16, 1, fp);
	fclose(fp);
	printf("sdiv loaded.\n");


	///////////////////////////////////////////////////////

	///////////////////////////////////
	// Read a source File
	printf("Input  : %s\n", argv[num]);
	if((fp = fopen(argv[num], "rb")) == NULL){
		printf("Cannot Open %s\n", argv[num]);
		return 0;
	}
	fseek(fp, 0x0L, SEEK_END);

	size = ftell(fp);
	if( (rBuffer = (unsigned char*)malloc( size )) == NULL ){
		printf("cannot allocate memory\n");
		return 0;
	}
	printf("Size   : %d\n", size);
	if((rBuffer2 = (unsigned char*)malloc( size )) == NULL){
		printf("cannot allocate memory\n");
		free(rBuffer);
		return 0;
	}
	memset(rBuffer,  0, size);
	memset(rBuffer2, 0, size);

	fseek(fp, 0x0L, SEEK_SET);
	fread(rBuffer, size, 1, fp);
	fclose(fp);


	if(mode == 0){
		printf("[E]ncrypt/[D]ecrypt?: ");
		c = getchar();
		if((c == 'e') || (c == 'E')) mode = 1;
		else if((c == 'd') || (c == 'D')) mode = 2;
	}

	///////////////////////////////////
	// Decrypt/Encrypt
	switch(mode){
		case 1:{
			aes_encrypt_ctx ctx[1];
			printf("*Encrypting...\n");
			aes_encrypt_key128(sdkey, ctx);
			aes_cbc_encrypt(rBuffer, rBuffer2, size, sdiv, ctx);
			break;
			}
		case 2:{
			aes_decrypt_ctx ctx[1];
			printf("*Decrypting...\n");
			aes_decrypt_key128(sdkey, ctx);
			aes_cbc_decrypt(rBuffer, rBuffer2, size, sdiv, ctx);
			break;
			}
		default:
			free(rBuffer);
			free(rBuffer2);
			return 0;
	}


	///////////////////////////////////
	// Output a File
	sprintf(name, "%s.%s", argv[num], mode==1?"enc":"dec");
	printf("Output : %s\n", name);
	if((fp = fopen(name, "wb")) == NULL){
		printf("Cannot Open %s\n", name);
		return 0;
	}
	fseek(fp, 0x0L, SEEK_SET);
	fwrite(rBuffer2, size, 1, fp);
	fclose(fp);

	free(rBuffer);
	free(rBuffer2);



	return 0;
}
